# SMALL
Spherical Microphone Arrays Little Library

Copyright 2023 Pierre Lecomte - sekisushai@gmail.com

The SMALL library provides an open-source set of Computer Aided Designs (CAD)s to easily 
build Spherical Microphone Arrays (SMA)s (i.e. Ambisonics mics) for research or home use. The 
designs are made with opensCAD, they are customizable and the different parts 
can be directly 3D printed. Extra standard mechanical assembly elements may be 
required such as screws or metal rods. 
Two configurations are proposed: open sphere or rigid sphere. 
The customization parameters are the array radius, the number and position of the microphones, their type and extra options such as the possibility to embed an USB sound card inside the array.
The microphone arrays signal processing for a Spherical Harmonic decomposition is provided as a code in the Faust language. 
Also, Python codes are provided for the calibration of the Spherical Microphone Arrays using a robotic arm. 

# opensCAD designs
The designs are in the `cad` folder:
- `sma_open.scad` for open SMA configuration with cylindrical shaped microphones,
- `sma_rigid.scad` for rigid SMA configuration with cylindrical shaped microphones,
- `sma_rigid_mchstreamer.scad` for rigid SMA configuration with digital MEMS microphone and embedded USB sound card.

Examples of SMA configurations are provide in `.json` files.
See the documentation in `.scad` files to create or customize a SMA design.

A tutorial on how to build a SMA using the SMALL library is available here:

to do

If you build a prototype by using the SMALL library, let me know :-) sekisushai@gmail.com

# SMA signal processing
To encode the microphones signals onto Spherical Harmonics signals (i.e. Ambisonics signals), one can use ambitools.
See www.sekisushai.net/ambitools/docs/mic_encoder.html for more infos.

# SMA calibration with a robotic arm
